<?php
class BookMark extends CWidget {
          private $baseUrl;

          public $id;
          public $sites = array();

          public function init() {
                    parent::init();
          }

          public function run() {
                    $this->publishAssets();
                    $this->registerClientScripts();
                    $this->registerCssFile();
                    echo $this->makeObjects();
          }

          public function getId(){
                    if(!isset($this->id))
                              $this->id = uniqid('jqbm');
                    return $this->id;
          }

          private function getArray($array) {
                    return (is_array($array))?$array:array();
          }

          private function makeObjects() {
                    $_html = CHtml::tag('span', array('id'=>$this->getId()), '', true);
                    return $_html;
          }

          public function registerClientScripts() {
                    if(!empty($this->sites)){
                              $siteslist = implode('\',\'', $this->sites);
                              $options = "{sites:['{$siteslist}']}";
                    }

                    $script = <<<XXX
                        $("#{$this->getId()}").bookmark({$options});
XXX;

                    $cs = Yii::app()->getClientScript();
                    $cs->registerCoreScript('jquery');
                    $url=$this->baseUrl.'/jquery.bookmark.min.js';
                    $cs->registerScriptFile($url,CClientScript::POS_HEAD);

                    $cs->registerScript('jqbm_'.$this->getId(), $script, CClientScript::POS_READY);
          }

          public function publishAssets() {
                    $dir = dirname(__FILE__) . DIRECTORY_SEPARATOR . 'vendors';
                    $this->baseUrl = Yii::app()->getAssetManager()->publish($dir);
          }

          public function registerCssFile($url=null) {
                    $url=$this->baseUrl."/jquery.bookmark.css";
                    Yii::app()->getClientScript()->registerCssFile($url,'screen');
          }
}
?>
